/*
nzev: crypt.cpp
autor: Pavel Hasenhrl
datum: 26.5.2009
verze: 1.0
*/

#include "crypt.h"
#include <tchar.h>

using namespace Exchanger;

CCrypto::CCrypto(const CConfig *_conf)
{
	m_hCmdOutWr = m_hCmdOutRd = m_hCmdInWr = m_hCmdInRd = NULL;
	m_hCmdProcess = m_hCmdThread = NULL;
	m_conf = _conf;
	Init();
}

CCrypto::~CCrypto()
{
	if(m_hCmdOutWr)
		CloseHandle(m_hCmdOutWr);
	if(m_hCmdOutRd)
		CloseHandle(m_hCmdOutRd);
	if(m_hCmdInWr)
		CloseHandle(m_hCmdInWr);
	if(m_hCmdInRd)
		CloseHandle(m_hCmdInRd);
	if(m_hCmdProcess)
		CloseHandle(m_hCmdProcess);
	if(m_hCmdThread)
		CloseHandle(m_hCmdThread);
}

bool CCrypto::Init()
{
	SECURITY_ATTRIBUTES saAttr;
	saAttr.nLength = sizeof(SECURITY_ATTRIBUTES);
	saAttr.bInheritHandle = TRUE;
	saAttr.lpSecurityDescriptor = NULL;

	if (!CreatePipe(&m_hCmdOutRd, &m_hCmdOutWr, &saAttr, 0))
		return false;

	SetHandleInformation(m_hCmdOutRd, HANDLE_FLAG_INHERIT, 0);

	if (!CreatePipe(&m_hCmdInRd, &m_hCmdInWr, &saAttr, 0)) {
		CloseHandle(m_hCmdOutWr);
		CloseHandle(m_hCmdOutRd);
		m_hCmdOutWr = m_hCmdOutRd = NULL;
		return false;
	}

	SetHandleInformation(m_hCmdInWr, HANDLE_FLAG_INHERIT, 0);

	PROCESS_INFORMATION piProcInfo; 
	STARTUPINFO siStartInfo;

	ZeroMemory(&piProcInfo, sizeof(PROCESS_INFORMATION));

	ZeroMemory(&siStartInfo, sizeof(STARTUPINFO));
	siStartInfo.cb = sizeof(STARTUPINFO);
	siStartInfo.hStdError = m_hCmdOutWr;
	siStartInfo.hStdOutput = m_hCmdOutWr;
	siStartInfo.hStdInput = m_hCmdInRd;
	siStartInfo.dwFlags = STARTF_USESHOWWINDOW | STARTF_USESTDHANDLES;
	siStartInfo.wShowWindow = SW_HIDE;

	TCHAR szCmdline[4096]; // dostatene velk buffer
	_tcscpy(szCmdline, TEXT("cmd.exe /K echo off"));

	if(CreateProcess(NULL, szCmdline, NULL, NULL, TRUE, 0, NULL, NULL, &siStartInfo, &piProcInfo)) {
		m_hCmdProcess = piProcInfo.hProcess;
		m_hCmdThread = piProcInfo.hThread;
		return true;
	}

	CloseHandle(m_hCmdOutWr);
	CloseHandle(m_hCmdOutRd);
	CloseHandle(m_hCmdInWr);
	CloseHandle(m_hCmdInRd);
	m_hCmdOutWr = m_hCmdOutRd = m_hCmdInWr = m_hCmdInRd = NULL;
	return false;
}

const char *CCrypto::EncryptFile(const char *_pass, const char *_file, unsigned int &_size)
{
	DWORD dwRead, dwWritten;

	strcpy(m_buffer, "scripts\\encrypt_file.bat \"");
	strcat(m_buffer, m_conf->GetEntryValueA(ET_PATH));
	strcat(m_buffer, "\" \"");
	strcat(m_buffer, _file);
	strcat(m_buffer, "\" ");
	strcat(m_buffer, _pass);
	strcat(m_buffer, "\n");

	dwRead = (DWORD)strlen(m_buffer);
	WriteFile(m_hCmdInWr, m_buffer, dwRead, &dwWritten, NULL);
	FlushFileBuffers(m_hCmdInWr);

	while(dwWritten) {
		ReadFile(m_hCmdOutRd, m_buffer, dwWritten, &dwRead, NULL);
		dwWritten -= dwRead;
	}

	// zalozeno na tom, ze openssl vraci jen tisknutelne znaky a \n
	// zatimco echo x vraci x\r\n - \r znamena konec
	dwWritten = MAX_FILE_SIZE;
	int last = -1;
	do {
		ReadFile(m_hCmdOutRd, m_buffer + (last + 1), dwWritten, &dwRead, NULL);
		dwWritten -= dwRead;
		last += dwRead;
	} while(dwWritten && m_buffer[last - 1] != '\r');

	last -= (sizeof("0\r\n") - 2);
	if(m_buffer[last] == '0' && dwWritten > 0) {
		_size = last;
		return m_buffer;
	}
	return NULL;
}

bool CCrypto::DecryptFile(const char *_pass, const char *_file, const char *_cipher, unsigned int _size)
{
	DWORD dwRead, dwWritten;

	// osetrit mozne bufferoverflow
	strcpy(m_buffer, "scripts\\decrypt_file.bat \"");
	strcat(m_buffer, m_conf->GetEntryValueA(ET_PATH));
	strcat(m_buffer, "\" \"");
	strcat(m_buffer, _file);
	strcat(m_buffer, "\" ");
	strcat(m_buffer, _pass);
	strcat(m_buffer, "\n");

	dwRead = (DWORD)strlen(m_buffer);
	WriteFile(m_hCmdInWr, m_buffer, dwRead, &dwWritten, NULL);
	FlushFileBuffers(m_hCmdInWr);

	while(dwWritten) {
		ReadFile(m_hCmdOutRd, m_buffer, dwWritten, &dwRead, NULL);
		dwWritten -= dwRead;
	}
	WriteFile(m_hCmdInWr, _cipher, _size, &dwRead, NULL);
	*m_buffer = 0x1a;
	WriteFile(m_hCmdInWr, m_buffer, 1, &dwRead, NULL);
	FlushFileBuffers(m_hCmdInWr);

	dwWritten = MAX_FILE_SIZE;
	int last = -1;
	do {
		ReadFile(m_hCmdOutRd, m_buffer + (last + 1), dwWritten, &dwRead, NULL);
		dwWritten -= dwRead;
		last += dwRead;
	} while(dwWritten && m_buffer[last - 1] != '\r');

	last -= (sizeof("0\r\n") - 2);
	if(m_buffer[last] == '0' && dwWritten > 0) { // pro jistotu
		return true;
	}
	return false;
}

const char *CCrypto::CryptData(const char *_pass, const char *_data, unsigned int &_size, bool _encrypt)
{
	DWORD dwRead, dwWritten;

	if(_encrypt)
		strcpy(m_buffer, "scripts\\encrypt_data.bat \"");
	else
		strcpy(m_buffer, "scripts\\decrypt_data.bat \"");
	strcat(m_buffer, m_conf->GetEntryValueA(ET_PATH));
	strcat(m_buffer, "\" ");
	strcat(m_buffer, _pass);
	strcat(m_buffer, "\n");

	dwRead = (DWORD)strlen(m_buffer);
	WriteFile(m_hCmdInWr, m_buffer, dwRead, &dwWritten, NULL);
	FlushFileBuffers(m_hCmdInWr);

	while(dwWritten) {
		ReadFile(m_hCmdOutRd, m_buffer, dwWritten, &dwRead, NULL);
		dwWritten -= dwRead;
	}
	WriteFile(m_hCmdInWr, _data, _size, &dwRead, NULL);
	*m_buffer = 0x1a;
	WriteFile(m_hCmdInWr, m_buffer, 1, &dwRead, NULL);
	FlushFileBuffers(m_hCmdInWr);

	// zalozeno na tom, ze openssl vraci jen tisknutelne znaky a \n
	// zatimco echo x vraci x\r\n - \r znamena konec
	dwWritten = MAX_FILE_SIZE;
	int last = -1;
	do {
		ReadFile(m_hCmdOutRd, m_buffer + (last + 1), dwWritten, &dwRead, NULL);
		dwWritten -= dwRead;
		last += dwRead;
	} while(dwWritten && m_buffer[last - 1] != '\r');

	last -= (sizeof("0\r\n") - 2);
	if(m_buffer[last] == '0' && dwWritten > 0) {
		_size = last;
		return m_buffer;
	}
	return NULL;
}
