/*
nzev: crypt.h
autor: Pavel Hasenhrl
datum: 26.5.2009
verze: 1.0
*/

#ifndef CRYPT_H
	#define CRYPT_H

#include <windows.h>
#include "config.h"

namespace Exchanger {

const unsigned int MAX_FILE_SIZE = 65536;

class CCrypto {
private:
	HANDLE m_hCmdOutWr, m_hCmdOutRd, m_hCmdInWr, m_hCmdInRd;
	HANDLE m_hCmdProcess, m_hCmdThread;
	char m_buffer[MAX_FILE_SIZE];
	const CConfig *m_conf;

	bool Init();
	const char *CryptData(const char *_pass, const char *_data, unsigned int &_size, bool _encrypt);
public:
	CCrypto(const CConfig *_conf);
	~CCrypto();

	const char *EncryptFile(const char *_pass, const char *_file, unsigned int &_size);
	bool DecryptFile(const char *_pass, const char *_file, const char *_cipher, unsigned int _size);
	const char *EncryptData(const char *_pass, const char *_data, unsigned int &_size) { return CryptData(_pass, _data, _size, true); }
	const char *DecryptData(const char *_pass, const char *_data, unsigned int &_size) { return CryptData(_pass, _data, _size, false); }
};

}

#endif
