/*
nzev: exchanger.h
autor: Pavel Hasenhrl
datum: 17.5.2009
verze: 1.0
*/

#ifndef EXCHANGER_H
	#define EXCHANGER_H

#include "config.h"
#include "server.h"

namespace Exchanger {

const unsigned int WM_EXCHANGER_NOTIFY = (WM_USER + 1);

struct CLIENTINFO_TYPE {
	char *name, *addr;
};

class CExchanger {
protected:
	const CConfig *m_conf;
	CPeer *m_peer;
	HWND m_hwnd;
public:
	CExchanger(const CConfig *_conf) { m_conf = _conf; m_peer = NULL; }
	~CExchanger();
	void Init(HWND _hwnd) { m_hwnd = _hwnd; }
	bool StartServer();
	bool StartClient();
	void Stop() { if(m_peer) { delete m_peer; m_peer = NULL; } }

	void AcceptClient(const char *_name, const char *_pass);
	void DeclineClient(const char *_name);
};

void NotifyCallback(NOTIFY_TYPE _event, const char *_name, const sockaddr_in *_addr);
bool SignCSR(const CConfig *_conf, const char *_client);

int AtoT(TCHAR * &dst, const char *src);

}

#endif
