/*
nzev: interface.h
autor: Pavel Hasenhrl
datum: 26.5.2009
verze: 1.0
*/

#ifndef INTERFACE_H
	#define INTERFACE_H

#include <tchar.h>
#include "manager.h"

enum INTERFACE_TYPE {
	IT_LOOPBACK,
	IT_BRIDGE,
	IT_TAP
};

bool ShellExecuteWait(DWORD& dwRet, int nShow, TCHAR *tcExe, TCHAR* tcWorkingDir, TCHAR* tcArgs);
void ShellExecuteAsync(TCHAR *tcExe, TCHAR* tcWorkingDir, TCHAR* tcArgs);
TCHAR *WrapCmdline(int length, const TCHAR * const argv[]);
template<bool wait> bool RunScript(TCHAR *line);
template<bool wait> bool RunScript(int length, const TCHAR * const argv[]);
TCHAR *AddInterface(const CConfig *_conf, INTERFACE_TYPE _type);
//bool InstallNic(INTERFACE_TYPE type);
bool RenameNic(const TCHAR *nic_name, const TCHAR *new_name);

template<bool wait> bool RunScript(TCHAR *line)
{
	DWORD ret = 0;
	if(wait)
		ShellExecuteWait(ret, SW_SHOWNORMAL, TEXT("cmd"), NULL, line);
	else
		ShellExecuteAsync(TEXT("cmd"), NULL, line);
	return (ret == 0);
}

template<bool wait> bool RunScript(int length, const TCHAR * const argv[])
{
	TCHAR *line = WrapCmdline(length, argv);

	DWORD ret = 0;
	if(wait)
		ShellExecuteWait(ret, SW_SHOWNORMAL, TEXT("cmd"), NULL, line);
	else
		ShellExecuteAsync(TEXT("cmd"), NULL, line);
	delete[] line;
	return (ret == 0);
}

#endif
